#include "hmg.ch"

* PUBLIC cLanguage, cCodePage, aTranslate

FUNCTION nls_init 

   if valtype(cLanguage) = 'U' .or. valtype(cCodePage) = 'U'
      msginfo('Insert line "PUBLIC cLanguage, cCodePage, aTranslate" in Main program ')
	  quit
   endif

   if ! file ("_LANG.dbf")
      alist_fld := {} 
      aadd(alist_fld,{"LINE","N",5,0})
      aadd(alist_fld,{"TEXT","C",50,0})
      dbcreate("_LANG",alist_fld)
   endif

   if ! file ("_LANG.ntx")
      use _LANG
      index on LINE to _LANG
      use 
   endif

   if !file ( "lang.ini")
       Begin ini file ("lang.ini")
       Set Section "Language" ENTRY "Language"  To 'english'
       Set Section "Language" ENTRY "CodePage"  To '1250'
       End ini
   endif
   
   Begin ini file ("lang.ini")
      Get cLanguage  Section "Language" ENTRY "Language"
      Get cCodePage  Section "Language" ENTRY "CodePage"
   End Ini

   nls_save_now() 
   
RETURN
*-------------------------------------------------------
FUNCTION use_lang()

   use _lang index _lang new

RETURN
*-------------------------------------------------------
FUNCTION nls_save_now ( )

   if ! file ("_TEMP.dbf")
      alist_fld := {} 
      aadd(alist_fld,{"LINIJA","C",100,0})
      dbcreate("_TEMP",alist_fld)
   endif

   use_lang()
   zap
   use _temp new
   zap

   set default to lang
   
   _nls = cLanguage + '.lng'

   if !file( _nls )
      msginfo( 'Language is not defined!')
      return
   endif

   select _temp
   append from (_nls) sdf

   set default to

   dbgotop()
   do while .not. eof()

      _linija = linija

      if !isdigit( substr(_linija,1,1) )
         dbskip()
         loop
      endif

      _eq = at('=',_linija)

      _line = val( substr( _linija,1,_eq-1 ))
      _text = substr( _linija,_eq+1,50 )
      _text = strtran ( _text, '"','' )

      select _lang
      dbappend()
      replace line with _line
      replace text with _text

      select _temp
      dbskip()
   enddo

   dbcloseall()

   nls_load()

RETURN 0
*-------------------------------------------------------
FUNCTION nls_select ()

  private aDir:={}, aFiles:={}

  aDir:=HB_DirScan( ".\lang", "*.lng" )

	For x:=1 to len(aDir)
	    _filen := strtran(adir[x,1],'.lng','')
	    aadd(afiles,_filen)
	next
	
    DEFINE WINDOW nls_select_Form ;
		AT 0,0 ;
		WIDTH 200 ;
		HEIGHT 150 ;
		TITLE 'Select language' ;
		MODAL 

		@ 10,10 COMBOBOX Combo_1 ;
			WIDTH 120 ;
			ITEMS afiles ;
			VALUE 1 ;
			ON ENTER get_select_lng ( nls_select_Form.Combo_1.value ) 
			
	END WINDOW
	
	CENTER WINDOW   nls_select_Form
	ACTIVATE WINDOW nls_select_Form

RETURN 0
*------------------------------------------------------------
FUNCTION GET_select_lng ( _val )

    _lng := afiles[ _val ]
    cLanguage := _lng

    nls_select_Form.release 
  
    nls_save_now() 
   
    Begin ini file ("lang.ini")
       Set Section "Language" ENTRY "Language"  To cLanguage
       Set Section "Language" ENTRY "CodePage"  To '1250'
    End ini 
   
RETURN _lng
*--------------------------------------------------------------
FUNCTION nls_load ()

   aTranslate:={}

   use _lang index _lang new

   do while .not. eof()
      aadd(aTranslate, { str(line), alltrim(text) } )
      dbskip()
   enddo

   dbcloseall()
   
RETURN 0
*------------------------------------
FUNCTION nls_lang( ii )

   local _word := '[ ' + alltrim(str(ii)) + ' ... ]'
 
   for i = 1 to len(aTranslate)

      if val(aTranslate[i,1]) = ii
         _word = aTranslate[i,2]
      endif
  
   next
   
RETURN _word


